function IO() {

}

IO.prototype.xcall = function(uri, method, root, args, operation, success, error) {
	var url = (operation !== "" ? (uri+"/"+root+"/"+args+"/"+operation+"/") : (uri+"/"+root+"/"+args+"/"));
	if (uri == "https://skybox-kauth.caps.services")
		url = url.slice(0, -1);
	$.ajax({
		url: url,
		type: method,
		headers: {
			'Authorization': $.cookie("panel_token")
		},
		xhrFields: {
			withCredentials: true
		}
	}).done(success).fail(error);
};

IO.prototype.pcall = function(uri, root, args, operation, data, success, error) {
	var url = uri+"/"+root+"/"+args+"/"+operation+"/";
	if (uri == "https://skybox-kauth.caps.services") {
		if (root == "config")
			url = url.slice(0, -2);
		else
			url = url.slice(0, -1);
	}
	$.ajax({
		url: url,
		type: "POST",
		data: JSON.stringify(data, null, '\t'),
		headers: {
			'Authorization': $.cookie("panel_token")
		},
		xhrFields: {
			withCredentials: true
		}
	}).done(success).fail(error);
};
