function Kbox(){
	this.Check = new Check();
	this.IO = new IO();
	this.configStatus = 0;
	// this.infoStatus = 0;
	//////////////////////
	this.Version_beta = "2.7";
	this.routercfg = null;
	this.new_routercfg = null;
	//////////////////////
	this.routerinfo = null;
	this.apinfo = null;
	//////////////////////
	this.sub_id = $.urlParam("s");
	this.mac = $.urlParam("mac");

	if (this.sub_id){
		var code = $.urlParam("code");
		if (code)
			this.getAccessToken(code);
		else
			this.getMacBySubID();
	} else if ((this.mac) && (this.__checkMac())) {
                this.getConfig();
	}

	this.lockinfo = false;
	this.modified = false;
	this.getinfo_error = false;
	//////////////////////
	this.subnet = "";
	this.lan_ports = ['1', '2', '3', '4'];
	//////////////////////
	this.lock_scan = false;
	this.lock_ping_admin = false;
	this.lock_gen_debug = false;
	this.lock_refresh_usb = false;
	this.lock_umount_usb = false;
	this.lock_run_wps = false;
	this.lock_run_auto_channel = false;
}

Kbox.prototype.__checkMac = function() {
	if (!this.mac || !this.mac.match(/^([0-9A-Fa-f]{2}([:])?){5}([0-9A-Fa-f]{2})$/)){
		$("#alert-server-error").html("<strong>Oups!</strong> Adresse MAC invalide.");
		$("#alert-server-error").parent().show();
		$("#loading").hide();
		this.configStatus = 500;
		return false;
	}
	return true;
};

Kbox.prototype.getInfos = function(force) {
	if (force || (! this.routerinfo && !this.lockinfo)) {
		if (force){
			$(".info-extract").show();
			$(".info-oups").hide();
		}
		this.lockinfo = true;
		var me = this;
		this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'infos',
			function(json) {
				me.routerinfo = $.sortobject(json["data"]);

				if ((((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850")) && (kbox.routerinfo.wireless['2.4Ghz'].status)) || (((kbox.routercfg.model === "v1") || (kbox.routercfg.model === "v2")) && (Object.keys(kbox.routerinfo.wireless).length != 0)))
					me.scanWIFI(null, {'is5Ghz': false}, false);
				me.lockinfo = false;
				me.getinfo_error = false;
				$(".load-bgrd").hide();
				$("#loading").hide();
				instance.update();
		}, 	function(errormsg) {
				$("#loading").hide();
				$(".info-extract").hide();
				$(".info-oups").show();
				switch(errormsg.status) {
					case 404:
					case 500:
					case 504:
						$(".info-oups").text('La KBOX est actuellement injoignable, réessayez ultérieurement');
						break;
					case 1501:
						$(".info-oups").text('Service indisponible, réessayez ultérieurement');
						break;
				}
				me.getinfo_error = true;
		});
	}
};

Kbox.prototype.setConfig = function() {
	$("#btn-event-close").prop("disabled", true);
	$(".event-bg").removeClass("alert-danger");
	$(".event-bg").addClass("alert-info");
	$(".save-alert").hide();
	$(".event-save").show();
	$(".event-save-txt").html('<table class="table borderless "><tr><td><img style="height:20px;margin-right:5px;" src="img/285.gif"/>Enregistrement des paramètres...</td></tr></table>');
	if (this.new_routercfg) {
		this.new_routercfg["mac_address"] = this.mac;
		var me = this;
		var bridge = (this.new_routercfg['mode_bridge'] && !this.routercfg['mode_bridge']) || (!this.new_routercfg['mode_bridge'] && this.routercfg['mode_bridge']);

		var param = (this.sub_id ? this.sub_id : this.mac);
		var root = (this.sub_id ? 'config' : 'router');
		var operation = (this.sub_id ? '' : 'config');

		this.IO.pcall(AREA.getSkyboxUrl(), root, param, operation, this.new_routercfg,
			function(json) {
				if (!json['data'].match(/need KBOX reboot/))
					var msg = "La configuration a été sauvegardée";
				else
					var msg = "La configuration a été sauvegardée mais n'a pas été appliquée sur la KBOX";
				$("#alert-server-error").parent().hide();
				$(".event-save-txt").html(msg);
				$("#btn-event-close").prop("disabled", false);
				me.routercfg = me.new_routercfg;
				me.new_routercfg = jQuery.extend(true, {}, me.routercfg);
				setTimeout(function(){
					$(".event-save").hide();
					$("#help-error").hide();
					$(".save-alert").hide();
				}, 5000);
				setTimeout(function () {
					me.getInfos(true);
				}, 15000);
				if (bridge)
					setTimeout(function(){
						window.location.reload();
					}, 1000);
		}, 	function(errormsg) {
				//Ugly patch when Icotera CPE reload all services and the server response is not received
				if(errormsg.hasOwnProperty("status")){
					switch(errormsg.status){
						case 401:
							$(".event-save-txt").text("Erreur lors de l'enregistrement de la configuration. Vous n'Ãªtes pas connectÃ©.");
							break;
						case 403:
							$(".event-save-txt").text("Erreur lors de l'enregistrement de la configuration. Vous n'Ãªtes pas autorisÃ© Ã  faire cette action.");
							break;
						default:
							try{
								var msg = errormsg["responseJSON"]["data"];
							}catch(e){
								var msg = "Erreur inconnue. Veuillez réprimander le responsable !";
							}
							$(".event-save-txt").html("Erreur lors de l'enregistrement de la configuration. Vérifiez les champs.<br/>Erreur retournée par le serveur: <b>\"" + msg + "\"</b>");
							$("#help-error").show();
							break;
					}
					$(".event-bg").removeClass("alert-info").addClass("alert-danger");
				} else {
					$("#alert-server-error").parent().hide();
					$(".event-save-txt").html("La configuration a été sauvegardée");
				}
				$("#btn-event-close").prop("disabled", false);
				setTimeout(function(){
					$(".event-save").hide();
					$("#help-error").hide();
					$(".save-alert").hide();
				}, 7000);
		});
	}
};

Kbox.prototype.getConfig = function(force) {
	if (force || (! this.routercfg && ! this.new_routercfg)) {
		var me = this;

		var param = (this.sub_id ? this.sub_id : this.mac);
		var root = (this.sub_id ? 'config' : 'router');
		var operation = (this.sub_id ? '' : 'config');

		this.IO.xcall(AREA.getSkyboxUrl(), "GET", root, param, operation,
			function(json) {
				me.configStatus = true;
				$("#alert-server-error").parent().hide();
				me.displayKMenu(json);
				
				me.routercfg = $.sortobject(json["data"]);
				me.new_routercfg = jQuery.extend(true, {}, me.routercfg);
				try {
					me.subnet = me.new_routercfg.lan_ip.match(/^.*\./)[0];
				}catch(e) {
					me.subnet = "";
				}
				me.configStatus = 200;
				me.checkBridgeMode();
				me.unlockAll();
				me.getInfos();
				// Critical function:
				try{
					instance.update();
					instance.onEvent();
				}catch(e){}
		}, 	function(errormsg) {
				me.configStatus = false;
				me.lockAll();
				$("#loading").hide();
				$("#popup-loading").hide();
				me.configStatus = errormsg.status;
				instance.update();
				$("#alert-server-error").parent().show();
				$("#alert-server-error").html("<strong>Oups!</strong><br/> Erreur retournée par le serveur: <b>" + errormsg["responseJSON"]["data"] + "</b>");
				$("#home_loading").addClass("toHide");
		});
	}
}

Kbox.prototype.getGroup = function() {
	var me = this;
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", "router", this.mac, "group/" + me.routercfg.model,
        function(data) {
		$("#run-update-group").prop("disabled", false);
		for(var pos in data['data']) {
			var group = data['data'][pos]['group'];
			if ((me.routercfg.model == "v1") || (me.routercfg.model == "v2"))
				var name = "Netgear " + me.routercfg.model + " " + data['data'][pos]['name'].split('_')[2].split('-')[0];
			else
				var name = "Icotera " + kbox.routercfg.model + " " + (data['data'][pos]['name'].split("_")[3]).replace('.bin', '');
			$('#select-update-group').append('<option value="'+group+'">'+name+" ("+group+")"+'</option>');
			if (me.routercfg.group == group){
				$('#select-update-group option[value="'+group+'"]').attr('selected','selected');
			}
                }
        },function(errormsg) {
                $("#alert-server-error").parent().show();
                $("#alert-server-error").html("<strong>Erreur !</strong> Impossible de récupérer les groupes associés au modèle de cette KBOX.");
		$("#run-update-group").prop("disabled", true);
                setTimeout(function(){
                        $("#alert-server-error").parent().hide();
                }, 5000);
        });
};

Kbox.prototype.updateGroup = function(group) {
        if (this.lock_update_group)
                return;
        this.lock_update_group = true;
        $("#loading").show();
        $("#run-update-group").hide();
        $("#run-update-group").prop("disabled",true);
        $("#loading-update-group").show();

        var me = this;
        this.IO.pcall(AREA.getSkyboxUrl(), "router", this.mac, "group", {"group": group},
                function(json) {
                        $("#loading-update-group").hide()
                        $("#value-update-group").text("");
                        $("#value-update-group").removeClass("glyphicon-remove");
                        $("#value-update-group").addClass("glyphicon-ok");
                        $("#run-update-group").show()
                        $("#run-update-group").prop("disabled",false);
                        me.lock_update_group = false;
                        $("#loading").hide();
                }, function(errormsg) {
                        $("#loading-update-group").hide()
                        $("#value-update-group").text("");
                        $("#value-update-group").removeClass("glyphicon-ok");
                        $("#value-update-group").addClass("glyphicon-remove");
                        $("#run-update-group").show()
                        $("#run-update-group").prop("disabled",false);
                        me.lock_update_group = false;
                        $("#loading").hide();
        });
}

Kbox.prototype.getMacBySubID = function() {
        var me = this;
        this.IO.xcall(AREA.getSkyboxUrl(), "GET", "router", this.sub_id, "",
            function(json) {
		try{
			me.mac = json['data']['mac'];
		}catch(e) {
			me.mac = null;
		}
                me.getConfig();
        }, function(errormsg) {
		switch(errormsg.status) {
			case 401:
				$("#alert-server-error").parent().show();
				$("#alert-server-error").html("<strong>Oups!</strong> Vous n'&eacute;tes pas connect&eacute;. Veuillez-vous rendre sur <a href='https://cocktail.caps.services'>Cocktail</a>.");
				return;
			case 403:
				$("#alert-server-error").parent().show();
				$("#alert-server-error").html("<strong>Erreur : </strong> vous n'avez pas accès à cette ressource.");
				$("#home_loading").addClass("toHide");
				return;
			case 500:
				$("#alert-server-error").parent().show();
				$("#alert-server-error").html("<strong>Oups!</strong> Erreur interne du serveur.<br/> Erreur retournée par le serveur: <b>" + errormsg["responseJSON"]["data"] + "</b>");
				$("#home_loading").addClass("toHide");
				return;
		}
        });
};

Kbox.prototype.getAccessToken = function(code) {
        var me = this;
        this.IO.xcall(AREA.getSkyboxUrl(), "GET", "access_token", code, "",
            function(json) {
		var date = new Date();
		date.setTime(date.getTime() + (6 * 3600 * 1000));
		$.cookie("panel_token", json["data"], { expires: date });
		url = window.location.href;
		window.location.href = url.substring(0, url.indexOf('&'));
        }, function(errormsg) {
				$("#alert-server-error").parent().show();
				$("#alert-server-error").html("<strong>Oups!</strong> Erreur interne du serveur.<br/> Erreur retournée par le serveur: <b>" + errormsg["responseJSON"]["data"] + "</b>");
				$("#home_loading").addClass("toHide");
        });
};

Kbox.prototype.checkBridgeMode = function() {
	if ((this.routercfg.mode_bridge) || (this.routercfg.display_ugly_panel)){
		$("#kmenu-lan").hide();
		$("#kmenu-wifi").hide();
		$("#kmenu-medias").hide();
		//////////////////////////
		if (menu.page == "lan" || menu.page == "wifi" || 
			menu.page == "medias")
			menu.goTo('info');
	}else{
		if (this.routercfg.vpn_client_if != "tap")
			$("#kmenu-lan").show();
		if ((this.routercfg.model != "mini-itx") || ((this.routercfg.is_unifi) && (this.routercfg.model == "mini-itx")))
			$("#kmenu-wifi").show();
		$("#kmenu-medias").show();
	}
};

Kbox.prototype.scanWIFI = function(onResultat, ctx, display) {
	var type_scan = (ctx.is5Ghz ? "5Ghz" : "2.4Ghz"); 
	var me = this;
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, "wifi/scan/" + type_scan, function(data){
		if (type_scan == '2.4Ghz')
			me.apinfo = data['data'];
		if (display) {
			onResultat(data, true, ctx);
			if (type_scan == '2.4Ghz')
				ctx.__check40Mhz();
		}
	},
	function(errormsg) {
		onResultat(data, false, ctx);
	});
};

Kbox.prototype.__getLANMacEth = function(stlist) {
	var prems = true;
	var me = this;
	if (kbox.new_routercfg.model === 'mini-itx') {
		var i = me.lan_ports.indexOf('4');
		if(i != -1)
			me.lan_ports.splice(i, 1);
		if (kbox.new_routercfg.failover_enable) {
			var i = me.lan_ports.indexOf('1');
			if(i != -1)
				me.lan_ports.splice(i, 1);
		}
	}
	for (var port in me.lan_ports) {
		if((this.new_routercfg.model === "i4600") || (this.new_routercfg.model === "i4850") || (kbox.new_routercfg.model === 'mini-itx')){
			for(var etherdev in this.routerinfo.port[me.lan_ports[port]].list_equipments) {
				var inuse = false;
				if (stlist) // LAN State equipment
					for(var st in stlist)
						if (stlist[st].mac_address == this.routerinfo.port[me.lan_ports[port]].list_equipments[etherdev].mac_addr){
							inuse = true;
							break;
						}
				for(var pos in this.routerinfo["list_dune"]){
					if (this.routerinfo["list_dune"][pos] == this.routerinfo.port[me.lan_ports[port]].list_equipments[etherdev].mac_addr){
						inuse = true;
						break;
					}
				}
				if (!inuse){
					if (prems) {
						$(".connected-equipment").each(function(){
							$(this).append('<li class="dropdown-header">ETHERNET</li>');
						});
						prems = false;
					}
					var equipment = ((this.routerinfo.port[me.lan_ports[port]].list_equipments[etherdev].name == "none") ||
					(this.routerinfo.port[me.lan_ports[port]].list_equipments[etherdev].name == null) ? 
					"Equipement inconnu" : this.routerinfo.port[me.lan_ports[port]].list_equipments[etherdev].name);
					$(".connected-equipment").each(function(){
						$(this).append(
							'<li><a class="host-item">'+me.routerinfo.port[me.lan_ports[port]].list_equipments[etherdev].mac_addr+' <i>('+
							equipment+')</i></a></li>'
						);
					});
				}
			}
		} else {
			if (this.routerinfo[this.lan_ports[port]].equipment != "00:00:00:00:00:00"){
				var inuse = false;
				if (stlist) // LAN State equipment
					for(var st in stlist)
						if (stlist[st].mac_address == this.routerinfo[this.lan_ports[port]].equipment){
							inuse = true;
							break;
						}
				for(var pos in this.routerinfo["list_dune"]){
					if (this.routerinfo["list_dune"][pos] == this.routerinfo[this.lan_ports[port]].equipment){
						inuse = true;
						break;
					}
				}
				if (!inuse){
					if (prems) {
						$(".connected-equipment").each(function(){
							$(this).append('<li class="dropdown-header">ETHERNET</li>');
						});
						prems = false;
					}
					var equipment = (this.routerinfo[this.lan_ports[port]].name_equipment == "none" ? "Equipement inconnu" : this.routerinfo[this.lan_ports[port]].name_equipment);
					$(".connected-equipment").each(function(){
						$(this).append(
							'<li><a class="host-item">'+me.routerinfo[me.lan_ports[port]].equipment+' <i>('+
							equipment+')</i></a></li>'
						);
					});
				}
			}
		}
	}
};

Kbox.prototype.__getLANMacWifi = function(stlist) {
	var prems = true;
	var me = this;

	if((this.new_routercfg.model === "i4600") || (this.new_routercfg.model === "i4850"))
		var wireless_equipments = this.routerinfo.wireless.list_equipments;
	else
		var wireless_equipments = this.routerinfo.wireless.list_equipment;

	for (var e in wireless_equipments) {
		var inuse = false;
		if (stlist) // LAN State equipment
			for(var st in stlist)
				if (stlist[st].mac_address == wireless_equipments[e].mac_addr){
					inuse = true;
					break;
				}
		if (!inuse){
			if (prems) {
				$(".connected-equipment").each(function(){
					$(this).append('<li class="dropdown-header">WIFI</li>');
				});
				prems = false;
			}
			var equipment = (wireless_equipments[e].name == "none" ? "Equipement inconnu" : wireless_equipments[e].name);
			var mac = wireless_equipments[e].mac_addr;

			$(".connected-equipment").each(function(){
				$(this).append('<li><a class="host-item">'+mac+' <i>('+equipment+')</i></a></li>');
			});
		}
	}
};

Kbox.prototype.getSTATICMac = function() {
	if (this.getinfo_error){
		$(".connected-equipment-ip").html('');
		$(".connected-equipment-ip").append(
			'<li><i>Impossible de joindre la KBox</i> <button onclick="javascript:window.location.reload(true);return false;" class="kbox-refresh btn btn-xs glyphicon glyphicon-refresh"></button></li>'
		);
		return;
	}
	if (this.routerinfo){
		var lan_ports = ['1', '2', '3', '4'];
		var used = [];
		$(".connected-equipment").html('');
		var prems = true;

		if (this.new_routercfg.model === 'netgear') {
			for (var port in lan_ports) {
				if (this.routerinfo[lan_ports[port]].equipment != "00:00:00:00:00:00" &&
					this.routerinfo[lan_ports[port]].state == "DOWN"){
					if (prems) {
						$(".connected-equipment").append('<li class="dropdown-header">ETHERNET</li>');
						prems = false;
					}
					var equipment = (this.routerinfo[lan_ports[port]].name_equipment == "none" ? "Equipement inconnu" : this.routerinfo[lan_ports[port]].name_equipment);
					$(".connected-equipment").append(
						'<li><a class="host-item">'+this.routerinfo[lan_ports[port]].equipment+' <i>('+
							equipment+')</i></a></li>'
					);
					used[used.length] = this.routerinfo[lan_ports[port]].equipment;
				}
			}
		}

		prems = true;
		var dhcpd_static = this.new_routercfg.lan_static_ip;
		for(var pos in dhcpd_static){
			if (prems) {
				$(".connected-equipment").append('<li class="dropdown-header">STATIQUE</li>');
				prems = false;
			}
			var rater = false;
			for(var p in used){
				if (used[p] == dhcpd_static[pos].mac){
					rater = true;
					break;
				}
			}
			if (!rater){
				$(".connected-equipment").append(
					'<li><a class="host-item">'+dhcpd_static[pos].mac+' <i>('+
						dhcpd_static[pos].description+')</i></a></li>'
				);
			}
		}
		if ($(".connected-equipment").html() == "")
			$(".connected-equipment").append("<i>Pas d'équipements éligibles.</i>");
	try{
	instance.updateEvent();
	}catch(e){}
	}
};

Kbox.prototype.getLANMac = function(list) {
	if (this.getinfo_error){
		$(".connected-equipment").each(function(){
			$(this).html('');
			$(this).append(
				'<li><i>Impossible de joindre la KBox</i> <button onclick="javascript:window.location.reload(true);return false;" class="kbox-refresh btn btn-xs glyphicon glyphicon-refresh"></button></li>'
			);
		});
		return;
	}
	if (this.routerinfo){
		$(".connected-equipment").each(function(){
			$(this).html('');
		});
		this.__getLANMacEth(list);
		if (this.routercfg.model != "mini-itx")
			this.__getLANMacWifi(list);
	$(".connected-equipment").each(function(){
		if ($(this).html() == "")
			$(this).append("<i>Pas d'équipements éligibles trouvés.</i>");
	});
	try{
	instance.updateEvent();
	}catch(e){}
	}
};

Kbox.prototype.getLANIp = function() {
	if (this.getinfo_error){
		$(".connected-equipment-ip").html('');
		$(".connected-equipment-ip").append(
			'<li><i>Impossible de joindre la KBox</i> <button onclick="javascript:window.location.reload(true);return false;" class="kbox-refresh btn btn-xs glyphicon glyphicon-refresh"></button></li>'
		);
		try{
		clearInterval(interval);
		}catch(e){}
		return;
	}
	if (this.routerinfo){
		$(".connected-equipment-ip").html('');
		var listIP = []

		if((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850") || (kbox.new_routercfg.model === "mini-itx")) {
			for(var pos in this.routerinfo.port){
				for (var etherdev in this.routerinfo.port[pos].list_equipments) {
					if (this.routerinfo.port[pos].list_equipments[etherdev].ip && this.routerinfo.port[pos].list_equipments[etherdev].ip != "none"){
						// Check for Dune:
						if (this.routerinfo["list_dune"]) {
								for(var p in this.routerinfo["list_dune"])
									if (this.routerinfo["list_dune"][p] != this.routerinfo.port[pos].list_equipments[etherdev].ip)
										listIP[listIP.length] = {"ip": this.routerinfo.port[pos].list_equipments[etherdev].ip, "name": this.routerinfo.port[pos].list_equipments[etherdev].name};
						}else{
							var name = ((this.routerinfo.port[pos].list_equipments[etherdev].name == "none") ||
							(this.routerinfo.port[pos].list_equipments[etherdev].name == null) ?
							"Equipement inconnu" : this.routerinfo.port[pos].list_equipments[etherdev].name);
							listIP[listIP.length] = {"ip": this.routerinfo.port[pos].list_equipments[etherdev].ip, "name": name};
						}
					}
				}
			}
		} else {
			for(var pos in this.routerinfo){
				if (this.routerinfo[pos].ip_equipment && this.routerinfo[pos].ip_equipment != "none"){
					// Check for Dune:
					if (this.routerinfo["list_dune"]) {
							for(var p in this.routerinfo["list_dune"])
								if (this.routerinfo["list_dune"][p] != this.routerinfo[pos].equipment)
									listIP[listIP.length] = {"ip": this.routerinfo[pos].ip_equipment, "name": this.routerinfo[pos].name_equipment};
					}else{
						var name = ((this.routerinfo[pos].name_equipment == "none") ||
						(this.routerinfo[pos].name_equipment == null) ?
						"Equipement inconnu" : this.routerinfo[pos].name_equipment);
						listIP[listIP.length] = {"ip": this.routerinfo[pos].ip_equipment, "name": name};
					}
				}
			}
		}

		if(kbox.new_routercfg.model != "mini-itx") {
			if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850"))
				var wireless_equipments = this.routerinfo.wireless.list_equipments;
			else
				var wireless_equipments = this.routerinfo.wireless.list_equipment;

			for(var pos in wireless_equipments){
				if (wireless_equipments[pos].ip && wireless_equipments[pos].ip != "none") {
					var name = ((wireless_equipments[pos].name == "none") || (wireless_equipments[pos].name == null) ?
					"Equipement inconnu" : wireless_equipments[pos].name);
					listIP[listIP.length] = {"ip": wireless_equipments[pos].ip, "name": name};
				}
			}
		}

		var stlist = this.routercfg.lan_static_ip;
		var exist = false;
		for(var pos in stlist){
			if (listIP.length == 0){
				listIP[listIP.length] = {"ip": stlist[pos].ip, "name": stlist[pos].description };
			}else{
				exist = false;
				for(var p in listIP){
					if (stlist[pos].ip == listIP[p].ip){
						exist = true;
						break;
					}
				}
				if (!exist)
					listIP[listIP.length] = {"ip": stlist[pos].ip, "name": stlist[pos].description };
			}
		}
		for(var pos in listIP) {
				$(".connected-equipment-ip").append(
					'<li><a class="host-item-ip">'+listIP[pos].ip+' <i>('+
					listIP[pos].name+')</i></a></li>'
				);
		}
		if ($(".connected-equipment-ip").html() == "")
			$(".connected-equipment-ip").append("<i>Pas d'équipements éligibles.</i>");
		try{
	instance.updateEvent();
	}catch(e){}
	}
};

Kbox.prototype.getLANIPv6 = function() {
	if (this.getinfo_error){
		$(".connected-equipment-ipv6").html('');
		$(".connected-equipment-ipv6").append(
			'<li><i>Impossible de joindre la KBox</i> <button onclick="javascript:window.location.reload(true);return false;" class="kbox-refresh btn btn-xs glyphicon glyphicon-refresh"></button></li>'
		);
		try{
			clearInterval(interval);
		}catch(e){}
		return;
	}

	if (this.routerinfo){
		$(".connected-equipment-ipv6").html('');
		var listIP = []

		for(var pos in this.routerinfo.port){
			for (var etherdev in this.routerinfo.port[pos].list_equipments) {
				if (this.routerinfo.port[pos].list_equipments[etherdev].ipv6 && this.routerinfo.port[pos].list_equipments[etherdev].ipv6 != "none"){
					var name = ((this.routerinfo.port[pos].list_equipments[etherdev].name == "none") ||
						    (this.routerinfo.port[pos].list_equipments[etherdev].name == null) ?
						    "Equipement inconnu" : this.routerinfo.port[pos].list_equipments[etherdev].name);

					listIP[listIP.length] = {"ipv6": this.routerinfo.port[pos].list_equipments[etherdev].ipv6, "name": name};
				}
			}
		}

		for(var pos in this.routerinfo.wireless.list_equipments){
			if (this.routerinfo.wireless.list_equipments[pos].ipv6 && this.routerinfo.wireless.list_equipments[pos].ipv6 != "none") {
				var name = ((this.routerinfo.wireless.list_equipments[pos].name == "none") ||
					    (this.routerinfo.wireless.list_equipments[pos].name == null) ?
					    "Equipement inconnu" : this.routerinfo.wireless.list_equipments[pos].name);

				listIP[listIP.length] = {"ipv6": this.routerinfo.wireless.list_equipments[pos].ipv6, "name": name};
			}
		}
	}

	for(var pos in listIP) {
		$(".connected-equipment-ipv6").append(
		  '<li><a class="host-item-ipv6">'+listIP[pos].ipv6+' <i>('+
		  listIP[pos].name+')</i></a></li>'
		);
	}
	if ($(".connected-equipment-ipv6").html() == "")
		$(".connected-equipment-ipv6").append("<i>Pas d'équipements éligibles.</i>");

	try{
		instance.updateEvent();
	} catch(e){}
};

Kbox.prototype.getRevs = function(callback) {
	var param = (this.sub_id ? this.sub_id : this.mac);
	var root = (this.sub_id ? 'config' : 'router');
	var operation = (this.sub_id ? 'all' : 'config/all');

	this.IO.xcall(AREA.getSkyboxUrl(), "GET", root, param, operation,
		function(json) {
			callback(json['data'])
		}, 	function(errormsg) {
			callback(null);
	});
};

Kbox.prototype.applyRev = function(id) {
	if (confirm("Voulez-vous appliquer une ancienne révision?")){
		$("#"+id).prop("disabled", true);
		$("#loading").show();
		var me = this;

		var param = (this.sub_id ? this.sub_id : this.mac);
		var root = (this.sub_id ? 'config' : 'router');
		var operation = (this.sub_id ? '' : 'config/');

		this.IO.xcall(AREA.getSkyboxUrl(), "GET", root, param, operation+id,
			function(json) {
				me.new_routercfg = json["data"];
				try {
					me.subnet = me.new_routercfg.lan_ip.match(/^.*\./)[0];
				}catch(e) {
					me.subnet = "";
				}
				me.showChange()
				$("#"+id).prop("disabled", false);
				$("#loading").hide();
			}, 	function(errormsg) {
				switch(errormsg.status) {
					case 401:
						$("#alert-server-error").parent().show();
						$("#alert-server-error").html("<strong>Erreur !</strong> Vous n'&eacute;tes pas connect&eacute;.");
						break;
				}
				$("#"+id).prop("disabled", false);
				$("#loading").hide();
		});
	}
};

Kbox.prototype.manage = function(controller) {
	if (controller != "reboot" && controller != "reset")
		return;
	var me = this;
	this.IO.xcall(AREA.getSkyboxUrl(), "GET",'router', this.mac, controller,
		function(json) {
			// Change page to wait (& ping router):
			me.page = "waiting";
			$(".klink").removeClass('active');
			$("#kcontent").load('html/waiting.html');
		},function(errormsg) {
			$("#alert-server-error").parent().show();
			$("#alert-server-error").html("<strong>Erreur !</strong> Impossible d'effectuer l'action.");
			$("#btn-reboot-entry").text("Redémarrer")
			$("#btn-reboot-entry").prop("disabled", false);
			$("#btn-reset-entry").text("Réinitialiser")
			$("#btn-reset-entry").prop("disabled", false);
			setTimeout(function(){
			$("#alert-server-error").parent().hide();
			}, 5000);
	});
};

Kbox.prototype.ping = function(host) {
	if(this.Check.checkhost(host)) {
		$("#loading").show();
    	$("#ping_div").html("Requête en cours ... ");
        $("#btn-ping-host").text("En cours...");
       	$("#btn-ping-host").prop('disabled',true);
       	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'ping/'+host.val(),
       	function(json) {
       		$("#loading").hide();
        	host.val("");
            host.parent().removeClass('has-success');
            $("#ping_div").html(json["data"]);
            $("#btn-ping-host").text("Confirmer");
            $("#btn-ping-host").prop('disabled',false);
            $("#panel-ping").addClass("panel-success");
            setTimeout(function() {
            	$("#panel-ping").removeClass("panel-success",500);
            }, 2000);
    	}, function(errormsg) {
    		$("#loading").hide();
        	try{
        		if (errormsg.status == 500)
            		$("#ping_div").html("Impossible de joindre l'hôte.");
        	}
        	catch(e){
            	$("#ping_div").html("<strong>Erreur !</strong> Impossible d'effectuer l'action.");
        	}
            $("#btn-ping-host").text("Confirmer");
            $("#btn-ping-host").prop('disabled',false);
            setTimeout(function(){
            	$("#alert-server-error").parent().hide();
            }, 5000);
    	});
		}
};

Kbox.prototype.traceroute = function(host) {
	if(this.Check.checkhost(host)) {
		$("#loading").show();
    	$("#traceroute_div").html("Requête en cours ... ");
        $("#btn-traceroute-host").text("En cours...");
       	$("#btn-traceroute-host").prop('disabled',true);
       	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'trace/'+host.val(),
       	function(json) {
       		$("#loading").hide();
        	host.val("");
            host.parent().removeClass('has-success');
            $("#traceroute_div").html(json["data"]);
            $("#btn-traceroute-host").text("Confirmer");
            $("#btn-traceroute-host").prop('disabled',false);
            $("#panel-traceroute").addClass("panel-success");
            setTimeout(function() {
            	$("#panel-traceroute").removeClass("panel-success",500);
            }, 2000);
    	}, function(errormsg) {
    		$("#loading").hide();
        	try{
        		if (errormsg.status == 500)
            		$("#traceroute_div").html("Impossible de joindre l'hôte.");
        	}
        	catch(e){
            	$("#traceroute_div").html("<strong>Erreur !</strong> Impossible d'effectuer l'action.");
        	}
            $("#btn-traceroute-host").text("Confirmer");
            $("#btn-traceroute-host").prop('disabled',false);
            setTimeout(function(){
            	$("#alert-server-error").parent().hide();
            }, 5000);
    	});
		}
};

Kbox.prototype.checkOnline = function() {
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", "router", this.mac, "ping/127.0.0.1/1",
	    function(json) {
	    	// Work!
	        instance.numberOkay++;
	        if (instance.numberOkay > 2){
	        	$("#a_kbox").attr("href", "javascript:menu.goTo('info')");
	        	kbox.getConfig(true);
	        	menu.goTo('info');
	        }
	        else
	        	setTimeout(function(){
	            kbox.checkOnline()
	    }, 5000);
	}, function(errormsg) {
		// Repinging again!
        setTimeout(function(){
                kbox.checkOnline()
        }, 5000);
	});	
};

Kbox.prototype.wol = function(e) {
	if (this.Check.checkmac(e)){
		$("#loading").show();
		$("#btn-wol").text("En cours...");
		$("#btn-wol").prop('disabled',true);
		this.IO.xcall(AREA.getSkyboxUrl(), "GET", "router", this.mac, "wol/"+e.val(),
		function(json) {
			$("#loading").hide();
			e.val("");
			e.parent().removeClass('has-success');
			$("#btn-wol").text("Confirmer");
			$("#btn-wol").prop('disabled',false);
			$("#panel-wol").addClass("panel-success");
			setTimeout(function() {
				$("#panel-wol").removeClass("panel-success",500);
			}, 2000);
		},function(errormsg) {
			$("#loading").hide();
			$("#alert-server-error").parent().show();
			$("#alert-server-error").html("<strong>Erreur !</strong> Impossible d'effectuer l'action.");
			$("#btn-wol").text("Confirmer");
			$("#btn-wol").prop('disabled',false);
			setTimeout(function(){
			$("#alert-server-error").parent().hide();
			}, 5000);
		});
	}
};

Kbox.prototype.genDebug = function(func) {
	if (this.lock_gen_debug)
		return;
	this.lock_gen_debug = true;
	$("#loading").show();
	$("#div-check-debug").hide();
	$("#loading-debug").show();
		
	var me = this;
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'debug/techsupport',
		function(json) {
			$("#loading-debug").hide()
			$("#div-check-debug").show()
			$("#value-check-debug").text("");
			$("#value-check-debug").removeClass("glyphicon-remove");
			$("#value-check-debug").addClass("glyphicon-ok");
			me.lock_gen_debug = false;
			$("#loading").hide();
		}, function(errormsg) {
			$("#loading-debug").hide()
			$("#div-check-debug").show()
			$("#value-check-debug").text("");
			$("#value-check-debug").removeClass("glyphicon-ok");
			$("#value-check-debug").addClass("glyphicon-remove");
			me.lock_gen_debug = false;
			$("#loading").hide();
	});
};

Kbox.prototype.refreshUSB = function(port) {
	if (this.lock_refresh_usb)
		return;
	this.lock_refresh_usb = true;
	$("#loading").show();
	$("#div-refresh-usb").hide();
	$("#loading-refresh-usb").show();
	$("#umount-usb").prop("disabled",true);
		
	var me = this;
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'debug/refresh/' + port,
		function(json) {
			$("#loading-refresh-usb").hide()
			$("#div-refresh-usb").show()
			$("#value-refresh-usb").text("");
			$("#value-refresh-usb").removeClass("glyphicon-remove");
			$("#value-refresh-usb").addClass("glyphicon-ok");
			$("#umount-usb").prop("disabled",false);
			me.lock_refresh_usb = false;
			$("#loading").hide();
		}, function(errormsg) {
			$("#loading-refresh-usb").hide()
			$("#div-refresh-usb").show()
			$("#value-refresh-usb").text("");
			$("#value-refresh-usb").removeClass("glyphicon-ok");
			$("#value-refresh-usb").addClass("glyphicon-remove");
			$("#umount-usb").prop("disabled",false);
			me.lock_refresh_usb = false;
			$("#loading").hide();
	});
};

Kbox.prototype.runWPS = function(is5Ghz) {
	if (this.lock_run_wps)
		return;
	if (is5Ghz) {
		var suffix = "5Ghz";
		var ap = 2;
	} else {
		var suffix = "24Ghz";
		var ap = 1
	}
	this.lock_run_wps = true;
	$("#loading").show();
	$("#div-wps_" + suffix).hide();
	$("#loading-wps_" + suffix).show();
	$("#run-wps_" + suffix).prop("disabled",true);

	var me = this;
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'wps/' + ap,
		function(json) {
			$("#loading-wps_" + suffix).hide()
			$("#div-wps_" + suffix).show()
			$("#value-wps_" + suffix).text("");
			$("#value-wps_" + suffix).removeClass("glyphicon-remove");
			$("#value-wps_" + suffix).addClass("glyphicon-ok");
			$("#run-wps_" + suffix).prop("disabled",false);
			me.lock_run_wps = false;
			$("#loading").hide();
		}, function(errormsg) {
			$("#loading-wps_" + suffix).hide()
			$("#div-wps_" + suffix).show()
			$("#value-wps_" + suffix).text("");
			$("#value-wps_" + suffix).removeClass("glyphicon-ok");
			$("#value-wps_" + suffix).addClass("glyphicon-remove");
			$("#run-wps_" + suffix).prop("disabled",false);
			me.lock_run_wps = false;
			$("#loading").hide();
	});
};

Kbox.prototype.runAutoChannel = function(is5Ghz) {
	if (this.lock_run_auto_channel)
		return;
	if (is5Ghz) {
		var suffix = "5Ghz";
		var ap = 2;
	} else {
		var suffix = "24Ghz";
		var ap = 1
	}
	this.lock_run_auto_channel = true;
	$("#loading").show();
	$("#run-auto-channel_" + suffix).hide();
	$("#run-auto-channel_" + suffix).prop("disabled",true);
	$("#loading-auto-channel_" + suffix).show();

	var me = this;
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'wifi/' + ap + '/channel/auto',
		function(json) {
			$("#loading-auto-channel_" + suffix).hide()
			$("#value-auto-channel_" + suffix).text("");
			$("#value-auto-channel_" + suffix).removeClass("glyphicon-remove");
			$("#value-auto-channel_" + suffix).addClass("glyphicon-ok");
			$("#run-auto-channel_" + suffix).show()
			$("#run-auto-channel_" + suffix).prop("disabled",false);
			me.lock_run_auto_channel = false;
			$("#loading").hide();
			setTimeout(function () {
				me.getInfos(true);
			}, (is5Ghz ? 15000 : 5000));
		}, function(errormsg) {
			$("#loading-auto-channel_" + suffix).hide()
			$("#value-auto-channel_" + suffix).text("");
			$("#value-auto-channel_" + suffix).removeClass("glyphicon-ok");
			$("#value-auto-channel_" + suffix).addClass("glyphicon-remove");
			$("#run-auto-channel_" + suffix).show()
			$("#run-auto-channel_" + suffix).prop("disabled",false);
			me.lock_run_auto_channel = false;
			$("#loading").hide();
	});
};

Kbox.prototype.umountUSB = function(port) {
	if (this.lock_umount_usb)
		return;
	this.lock_umount_usb = true;
	$("#loading").show();
	$("#div-umount-usb").hide();
	$("#loading-umount-usb").show();
	$("#refresh-usb").prop("disabled",true);
		
	var me = this;
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'debug/umount/' + port,
		function(json) {
			$("#loading-umount-usb").hide()
			$("#div-umount-usb").show()
			$("#value-umount-usb").text("");
			$("#value-umount-usb").removeClass("glyphicon-remove");
			$("#value-umount-usb").addClass("glyphicon-ok");
			$("#refresh-usb").prop("disabled",false);
			me.lock_umount_usb = false;
			$("#loading").hide();
		}, function(errormsg) {
			$("#loading-umount-usb").hide()
			$("#div-umount-usb").show()
			$("#value-umount-usb").text("");
			$("#value-umount-usb").removeClass("glyphicon-ok");
			$("#value-umount-usb").addClass("glyphicon-remove");
			$("#refresh-usb").prop("disabled",false);
			me.lock_umount_usb = false;
			$("#loading").hide();
	});
};

Kbox.prototype.getLog = function() {
	$("#log_div").html("Requête en cours ... ");
	$("#btn-log").prop('disabled',true);
	$("#loading").show();
    this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'log',
       	function(json) {
			$("#loading").hide();
	      	$("#log_div").html(json["data"]);
			$("#log_div").scrollTop($("#log_div")[0].scrollHeight - $("#log_div").height());
	       	$("#btn-log").prop('disabled',false);
	       	$("#panel-log").addClass("panel-success");
	       	setTimeout(function() {
		       $("#panel-log").removeClass("panel-success",500);
	       	}, 2000);
       	}, function(errormsg) {
			$("#loading").hide();
	       	$("#alert-server-error").parent().show();
	       	$("#log_div").html("Erreur ! Impossible d'effectuer l'action.");
	       	$("#btn-log").prop('disabled',false);
	       	setTimeout(function(){
			$("#alert-server-error").parent().hide();
	       	}, 5000);
      	});
};

Kbox.prototype.getArp = function() {
	$("#arp-table-div").html("Requête en cours ... ");
	$("#btn-arp-table").prop('disabled',true);
	$("#loading").show();
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'arp',
		function(json) {
			$("#loading").hide();
			$("#arp-table-div").html(json["data"]);
			$("#arp-table-div").scrollTop($("#arp-table-div")[0].scrollHeight - $("#arp-table-div").height());
			$("#btn-arp-table").prop('disabled',false);
			$("#panel-arp-table").addClass("panel-success");
			setTimeout(function() {
			       $("#panel-arp-table").removeClass("panel-success",500);
			}, 2000);
		}, function(errormsg) {
			$("#loading").hide();
			$("#alert-server-error").parent().show();
			$("#arp-table-div").html("Erreur ! Impossible d'effectuer l'action.");
			$("#btn-arp-table").prop('disabled',false);
			setTimeout(function(){
				$("#alert-server-error").parent().hide();
			}, 5000);
	});
};

Kbox.prototype.getCallLog = function() {
	$("#table-phone-elcon").html("<tr><td>Obtention de l'historique des appels ... </td></tr>");
	$("#btn-phone-log").prop('disabled',true);
    this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'calls',
       	function(json) {
		if((!json.hasOwnProperty('data')) || (Object.keys(json['data']).length === 0)) {
       			$("#table-phone-elcon").html("<tr><td>Aucun historique des appels</td></tr>");
       		} else {
	       		var content_gcl="<tr class=\"active\"><th>Début</th><th>Source</th><th>Destination</th>"+
	       						"<th>Durée</th><th>Etat</th><th>Codec</th><th>Direction</th><th>Jitter max</th>"+
	       						"<th>Paquets perdus</th></tr>";
	       		for(var calllog in json["data"]) {
	       			content_gcl+="<tr><td>"+json["data"][calllog]["started"]+"</td>"+
	       						 "<td>"+json["data"][calllog]["src"]+"</td>"+
	       						 "<td>"+json["data"][calllog]["dst"]+"</td>"+
	       						 "<td>"+json["data"][calllog]["duration"]+"</td>"+
	       						 "<td>"+json["data"][calllog]["status"]+"</td>"+
	       						 "<td>"+json["data"][calllog]["codec"]+"</td>"+
	       						 "<td>"+json["data"][calllog]["dir"]+"</td>"+
	       						 "<td>"+json["data"][calllog]["max_jitter"]+"</td>"+
	       						 "<td>"+json["data"][calllog]["pkts_lost"]+"</td></tr>"
	       		}
	       		$("#table-phone-elcon").html(content_gcl);
	       	}
       		$("#btn-phone-log").prop('disabled',false);
       	}, function(errormsg) {
       		$("#table-phone-elcon").html("<tr><td><strong>Erreur !</strong> Impossible de récupérer l'historique des appels</td></tr>");
       		$("#btn-phone-log").prop('disabled',false);
      	});
};

Kbox.prototype.getUpnpRules = function() {
	$("#table-upnp-rules").html("<tr><td>Obtention des règles UPnP actives ... </td></tr>");
	$("#btn-upnp-rules").prop('disabled',true);
    this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'debug/upnp',
       	function(json) {
		if((!json.hasOwnProperty('data')) || (Object.keys(json['data']).length === 0)) {
       			$("#table-upnp-rules").html("<tr><td> Aucune règle UPnP active</td></tr>");
       		} else {
	       		var content_gur="<tr class=\"active\"><th>IP de destination</th><th>Port source</th><th>Port destination</th>"+
	       						"<th>Protocole</th>";
	       		for(var rule in json["data"]) {
	       			content_gur+="<tr><td>"+json["data"][rule]["ip"]+"</td>"+
	       						 "<td>"+json["data"][rule]["ext_port"]+"</td>"+
	       						 "<td>"+json["data"][rule]["int_port"]+"</td>"+
	       						 "<td>"+json["data"][rule]["proto"]+"</td>"
	       		}
	       		$("#table-upnp-rules").html(content_gur);
	       	}
	       	$("#btn-upnp-rules").prop('disabled',false);
       	}, function(errormsg) {
       		$("#table-upnp-rules").html("<tr><td><strong>Erreur !</strong> Impossible de récupérer les règles UPnP actives</td></tr>");
       		$("#btn-upnp-rules").prop('disabled',false);
      	});
};

Kbox.prototype.getPackagesList = function() {
        $("#upgrade_packages_div").html("Requête en cours ... ");
        $("#btn-upgrade-packages").prop('disabled',true);
        $("#loading").show();
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'packages/list',
        function(json) {
		$("#loading").hide();
		if(json['data'] == "Listing...\n")
			$("#upgrade_packages_div").html("Les paquets sont à jour !");
		else
			$("#upgrade_packages_div").html(json["data"]);
		$("#upgrade_packages_div").scrollTop($("#upgrade_packages_div")[0].scrollHeight - $("#upgrade_packages_div").height());
                $("#btn-upgrade-packages").prop('disabled',false);
                $("#panel-upgrade-packages").addClass("panel-success");
                setTimeout(function() {
                       $("#panel-upgrade-packages").removeClass("panel-success",500);
                }, 2000);
        }, function(errormsg) {
		$("#loading").hide();
                $("#alert-server-error").parent().show();
                $("#upgrade_packages_div").html("Erreur ! Impossible d'effectuer l'action.");
                $("#btn-upgrade-packages").prop('disabled',false);
                setTimeout(function(){
                        $("#alert-server-error").parent().hide();
                }, 5000);
        });
};

Kbox.prototype.upgradePackages = function() {
        $('#div-upgrade-packages').hide();
        $('#loading').show();
        $('#loading-upgrade-packages').show();
        this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'packages/upgrade',
                function(json) {
                        $('#loading').hide();
                        $('#loading-upgrade-packages').hide()
                        $('#div-upgrade-packages').show()
                        $('#value-upgrade-packages').text("");
                        $('#value-upgrade-packages').removeClass("glyphicon-remove");
                        $('#value-upgrade-packages').addClass("glyphicon-ok");
                        $('#run-upgrade-packages').prop("disabled",false);
                }, function(errormsg) {
                        $('#loading').hide();
                        $('#loading-upgrade-packages').hide()
                        $('##div-upgrade-packages').show()
                        $('#value-upgrade-packages').text("");
                        $('#value-upgrade-packages').removeClass("glyphicon-ok");
                        $('#value-upgrade-packages').addClass("glyphicon-remove");
                        $('#run-upgrade-packages').prop("disabled",false);
        });
};

Kbox.prototype.supervisionGraph = function(type) {
	var param = (this.sub_id ? this.routercfg.rate_entity : this.routercfg.client_id);
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", "pro", param, "graph/bandwidth/"+type,
	function(data) {
		try{
			if (!data)
				throw "ERROR DATA!";
				$("#sup_" + type).attr('src', 'data:image/png;base64,'+data);
			}catch(e){
				$("#alert-server-error").html("<strong>Erreur !</strong> Impossible de récupérer les graphes.");
				$("#alert-server-error").parent().show();
				setTimeout(function(){
					$("#alert-server-error").parent().hide();
				}, 5000);
			}
		},function(errormsg) {
			$("#alert-server-error").parent().show();
			$("#alert-server-error").html("<strong>Erreur !</strong> Impossible de récupérer les graphes.");
			setTimeout(function(){
				$("#alert-server-error").parent().hide();
			}, 5000);
	});
};

Kbox.prototype.getMonitGraph = function(timeformat, type) {
	var param = (this.sub_id ? this.routercfg.monit_entity : this.routercfg.client_id);
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", "pro", param, "graph/monit/"+this.mac+"/"+timeformat+"/"+type,
	function(data) {
		try{
			if (!data)
				throw "ERROR DATA!";
				$("#"+type+"_"+timeformat).attr('src', 'data:image/png;base64,'+data);
			}catch(e){
				$("#alert-server-error").html("<strong>Erreur !</strong> Impossible de récupérer les graphes de monitoring.");
				$("#alert-server-error").parent().show();
				setTimeout(function(){
					$("#alert-server-error").parent().hide();
				}, 5000);
			}
		},function(errormsg) {
			$("#alert-server-error").parent().show();
			$("#alert-server-error").html("<strong>Erreur !</strong> Impossible de récupérer les graphes de monitoring.");
			setTimeout(function(){
				$("#alert-server-error").parent().hide();
			}, 5000);
	});
};

Kbox.prototype.getOpenvpnClient = function() {
	var param = (this.sub_id ? this.routercfg.vpn_entity : this.routercfg.client_id);
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", "pro", param, "vpn",
	function(data) {
		var i = 0;
		for(var pos in data['data']) {
			if(data['data'][pos]['enable'] == 1) {
				var class_state = 'glyphicon-check';
				var desc_state = 'Désactiver le VPN client';
			} else {
				var class_state = 'glyphicon-unchecked';
				var desc_state = 'Activer le VPN client';
			}

			$("#tr-add-vpn").before(
				'<tr id="vpn_'+i+'""><td id="vpn_name_'+i+'"">'+data['data'][pos]['description']+'</td><td>'+
				//'<button id="vpn_button_'+i+'"" class="vpn-button glyphicon '+class_state+'" type="button" style="margin-right:10px;" data-toggle="tooltip" data-original-title="'+desc_state+'" onclick="javascript:instance.changeStateVPNClient(\''+i+'\');"></button>'+
				'<button class="vpn-button glyphicon glyphicon-remove" type="button" style="margin-right:10px;" data-toggle="tooltip" data-original-title="Supprimer le VPN client" onclick="javascript:instance.removeVPNClient(\''+i+'\');"></button>'+
				'<button class="vpn-button glyphicon glyphicon-download-alt" type="button" data-toggle="tooltip" data-original-title="Téléchargement des certificats et de la clé" onclick="javascript:instance.downloadVPNClient(\''+i+'\');"></button></td></tr>'
			);
			i += 1;
		}
	},function(errormsg) {
		$("#alert-server-error").parent().show();
		$("#alert-server-error").html("<strong>Erreur !</strong> Impossible de récupérer les clients VPN associés à ce serveur.");
		setTimeout(function(){
			$("#alert-server-error").parent().hide();
		}, 5000);
	});
};

Kbox.prototype.updateStateVPNClient = function(desc, enable, btn_id) {
	$("#loading_vpn").removeClass("toHide");
	$.disableElementsByClass("vpn-button");
	var vpn = {"description": desc, "enable": enable}
	var param = (this.sub_id ? this.routercfg.vpn_entity : this.routercfg.client_id);
	this.IO.pcall(AREA.getSkyboxUrl(), "pro", param, "vpn", vpn,
	function(data) {
		setTimeout(function(){
			if(enable == 1){
				$("#vpn_button_" + btn_id).removeClass("glyphicon-unchecked");
				$("#vpn_button_" + btn_id).addClass("glyphicon-check");
				$("#vpn_button_" + btn_id).attr('data-original-title', "Désactiver le VPN");
			} else {
				$("#vpn_button_" + btn_id).removeClass("glyphicon-check");
				$("#vpn_button_" + btn_id).addClass("glyphicon-unchecked");
				$("#vpn_button_" + btn_id).attr('data-original-title', "Activer le VPN");
			}
			$("#loading_vpn").addClass("toHide");
			$.enableElementsByClass("vpn-button");
		}, 2000);
	},function(errormsg) {
		$("#alert-server-error").parent().show();
		$("#alert-server-error").html("<strong>Erreur !</strong> Impossible d'activer/désactiver le client VPN.");
		$.enableElementsByClass("vpn-button");
		setTimeout(function(){
			$("#alert-server-error").parent().hide();
		}, 5000);
	});
};

Kbox.prototype.deleteVPNClient = function(desc, btn_id) {
	$("#loading_vpn").removeClass("toHide");
	$.disableElementsByClass("vpn-button");
	var param = (this.sub_id ? this.routercfg.vpn_entity : this.routercfg.client_id);
	this.IO.xcall(AREA.getSkyboxUrl(), "DELETE", "pro", param, "vpn/"+desc,
	function(data) {
		setTimeout(function(){
			$("#vpn_" + btn_id).remove();
			$("#loading_vpn").addClass("toHide");
			$.enableElementsByClass("vpn-button");
		}, 2000);
	},function(errormsg) {
		$("#alert-server-error").parent().show();
		$("#alert-server-error").html("<strong>Erreur !</strong> Impossible de supprimer le client VPN.");
		$.enableElementsByClass("vpn-button");
		setTimeout(function(){
			$("#alert-server-error").parent().hide();
		}, 5000);
	});
};

Kbox.prototype.addVPNClient = function(desc, btn_id) {
	$("#loading_vpn").removeClass("toHide");
	$.disableElementsByClass("vpn-button");
	var vpn = {"description": desc}
	var param = (this.sub_id ? this.routercfg.vpn_entity : this.routercfg.client_id);
	this.IO.pcall(AREA.getSkyboxUrl(), "pro", param, "vpn", vpn,
	function(data) {
		setTimeout(function(){
			$("#tr-add-vpn").before(
				'<tr id="vpn_'+btn_id+'""><td id="vpn_name_'+btn_id+'"">'+desc+'</td><td>'+
				//'<button id="vpn_button_'+btn_id+'"" class="vpn-button glyphicon glyphicon-check" type="button" style="margin-right:10px;" data-toggle="tooltip" data-original-title="Désactiver le VPN client" onclick="javascript:instance.changeStateVPNClient(\''+btn_id+'\');"></button>'+
				'<button class="vpn-button glyphicon glyphicon-remove" type="button" style="margin-right:10px;" data-toggle="tooltip" data-original-title="Supprimer le VPN client" onclick="javascript:instance.removeVPNClient(\''+btn_id+'\');"></button>'+
				'<button class="vpn-button glyphicon glyphicon-download-alt" type="button" data-toggle="tooltip" data-original-title="Téléchargement des certificats et de la clé" onclick="javascript:instance.downloadVPNClient(\''+btn_id+'\');"></button></td></tr>'
			);
			$("#loading_vpn").addClass("toHide");
			$("#vpn-name").val("");
			$.enableElementsByClass("vpn-button");
		}, 2000);
	},function(errormsg) {
		$("#alert-server-error").parent().show();
		$("#alert-server-error").html("<strong>Erreur !</strong> Impossible de supprimer le client VPN.");
		$.enableElementsByClass("vpn-button");
		setTimeout(function(){
			$("#alert-server-error").parent().hide();
		}, 5000);
	});
};

Kbox.prototype.downloadVPNClient = function(desc) {
	$("#loading_vpn").removeClass("toHide");
	$.disableElementsByClass("vpn-button");
	var me = this;
	var param = (this.sub_id ? this.routercfg.vpn_entity : this.routercfg.client_id);
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", "pro", param, "vpn/infos/" + desc,
	function(data) {
		setTimeout(function(){
			$("#loading_vpn").addClass("toHide");
			try {
				var ip_wan = me.routerinfo.ip_wan;
			} catch (e) {
				var ip_wan = "<VPN SERVER IP ADDRESS>";
			}
			var conf_openvpn_linux = "remote "+ ip_wan +"\ndev "+ me.routercfg.vpn_server_if +"\ncipher AES-256-CBC\n" +
			"ca\t/etc/openvpn/keys/ca.crt\ncert\t/etc/openvpn/keys/client.crt\nkey\t/etc/openvpn/keys/client.key\n" +
			"tls-client\nproto tcp-client\npull\ncomp-lzo\nremote-cert-tls server";
			var conf_openvpn_windows = "client\ndev "+ me.routercfg.vpn_server_if + "\nproto tcp\nremote "+ ip_wan +
			"\nresolv-retry infinite\nnobind\npersist-key\npersist-tun\nmute-replay-warnings\n"+
			"ca\t\"C:\\\\Program Files\\\\OpenVPN\\\\config\\\\ca.crt\"\ncert\t\"C:\\\\Program Files\\\\OpenVPN\\\\config\\\\client.crt\"\n"+
			"key\t\"C:\\\\Program Files\\\\OpenVPN\\\\config\\\\client.key\"\ncipher AES-256-CBC\ncomp-lzo\nverb 5";
			var zip = new JSZip();
			zip.file("client.key", data['data']['pkey']);
			zip.file("client.crt", data['data']['crt']);
			zip.file("ca.crt", data['data']['ca']);
			zip.file("linux.conf", conf_openvpn_linux);
			zip.file("windows.ovpn", conf_openvpn_windows);
			zip.generateAsync({type:"blob"})
			.then(function(content) {
				saveAs(content, "vpn.zip");
			});
			$.enableElementsByClass("vpn-button");
		}, 2000);
	},function(errormsg) {
		$("#alert-server-error").parent().show();
		$("#alert-server-error").html("<strong>Erreur !</strong> Impossible de supprimer le client VPN.");
		$.enableElementsByClass("vpn-button");
		setTimeout(function(){
			$("#alert-server-error").parent().hide();
		}, 5000);
	});
};

Kbox.prototype.__hasChanged = function() {
	this.modified = true;
	if (JSON.stringify(this.routercfg) == JSON.stringify(this.new_routercfg)) {
		$(".has-error").removeClass('has-error');
		$(".has-success").removeClass('has-success');
		this.modified = false;
	}

	return this.modified;
};

Kbox.prototype.showChange = function() {
	if (this.__hasChanged()) {
		if ($(".has-error").length > 0 ||
		   ($("#mac_bridge").parent().hasClass('has-success') &&
		    !this.new_routercfg.mode_bridge))
			$("#btn-save-alert").addClass('disabled');
		else
			$("#btn-save-alert").removeClass('disabled');
		$(".save-alert").show();
	}
	else
		$(".save-alert").hide();
};

Kbox.prototype.remove_dhcpd_static_entry = function(id) {
	if (this.new_routercfg.lan_static_ip[id])
		this.new_routercfg.lan_static_ip.splice(id,1);
}

Kbox.prototype.tolist = function(e, classValue) {
	return $("." + classValue).map(function() { return $(this).val();}).get();
};

Kbox.prototype.rollBack = function() {
	this.new_routercfg = jQuery.extend(true, {}, this.routercfg);
	this.subnet = this.new_routercfg.lan_ip.match(/^.*\./)[0];
	$(".has-error").removeClass('has-error');
	$(".has-success").removeClass('has-success');
	try{instance.rollBack();}catch(e){}
};

Kbox.prototype.add_dhcpd_static_entry = function(ip, mac, name) {
	var stlist = this.new_routercfg.lan_static_ip;
	var len = 0;
	for (var st in stlist) {
		if (stlist[st].ip == ip)
			return false;
		if (stlist[st].mac == mac)
			return false;
		// don't care about the name
		len++;
	}
	this.new_routercfg.lan_static_ip[len] = { mac: mac, ip: ip, description: name };
};

Kbox.prototype.wifi_rule_add = function(name, active_days, begin, end, active, is5Ghz) {
	var timeslot_acl = ( !is5Ghz ? this.new_routercfg.wifi_acl_timeslot : this.new_routercfg.wifi_acl_timeslot_5Ghz)
	if (!timeslot_acl)
		timeslot_acl = [];
	var rulist = timeslot_acl;
	var len = 0;
	for (var idx in rulist) {
		if (rulist[idx].desc == name)
			return false;
		len++;
	}
	timeslot_acl[len] = {
		"days_restrict": active_days,
		"begin_restrict": begin,
		"end_restrict": end,
		"active": active,
		"description": name
	};

	if(is5Ghz)
		this.new_routercfg.wifi_acl_timeslot_5Ghz = timeslot_acl
	else
		this.new_routercfg.wifi_acl_timeslot = timeslot_acl

	return true;
};

Kbox.prototype.wifi_restrict_add = function(mac, is5Ghz) {
	var mac_acl = ( !is5Ghz ? this.new_routercfg.mac_acl_24Ghz : this.new_routercfg.mac_acl_5Ghz)
	if (!mac_acl)
		mac_acl = [];
	var maclist = mac_acl;
	var len = 0;
	for (var idx in maclist) {
		if (maclist[idx] == mac)
			return false;
		len++;
	}
	mac_acl[len] = mac;

	if(is5Ghz)
		this.new_routercfg.mac_acl_5Ghz = mac_acl
	else
		this.new_routercfg.mac_acl_24Ghz = mac_acl
};


Kbox.prototype.wifi_rule_del = function(id, is5Ghz) {
	if(is5Ghz) {
		if (this.new_routercfg.wifi_acl_timeslot_5Ghz[id])
			this.new_routercfg.wifi_acl_timeslot_5Ghz.splice(id, 1);
	} else {
		if (this.new_routercfg.wifi_acl_timeslot[id])
			this.new_routercfg.wifi_acl_timeslot.splice(id, 1);
	}
};

Kbox.prototype.wifi_restrict_remove = function(id, is5Ghz) {
	if(is5Ghz) {
		if (this.new_routercfg.mac_acl_5Ghz[id])
			this.new_routercfg.mac_acl_5Ghz.splice(id,1);
	} else {
		if (this.new_routercfg.mac_acl_24Ghz[id])
			this.new_routercfg.mac_acl_24Ghz.splice(id,1);
	}
};

Kbox.prototype.add_port_rule = function(name, proto, src_ip, src_port,
								 dest_ip, dest_port, active) {
	if (!this.new_routercfg.portforward)
		this.new_routercfg.portforward = [];
	var plist = this.new_routercfg.portforward;
	var len = 0;
	for (var idx in plist) {
		if (plist[idx].description == name)
			return false;
		len++;
	}
	this.new_routercfg.portforward[len] = {
		"active": active,
		"proto": proto,
		"src_ip": src_ip,
		"ext_port": src_port,
		"int_ip": dest_ip,
		"int_port": dest_port,
		"description": name
	};
};

Kbox.prototype.add_fire_rule = function(name, target, proto, src_ip, src_port,
								dst_ip, dst_port, src_mac, active) {
	if (!this.new_routercfg.firewall)
		this.new_routercfg.firewall = [];
	var flist = this.new_routercfg.firewall;
	var len = 0;
	for (var idx in flist) {
		if (flist[idx].description == name)
			return false;
		len++;
	}
	this.new_routercfg.firewall[len] = {
		"active": active,
		"target": target,
		"proto": proto,
		"src_ip": src_ip,
		"src_port": src_port,
		"dst_ip": dst_ip,
		"dst_port": dst_port,
		"src_mac": src_mac,
		"description": name
	};
};

Kbox.prototype.add_bridge_rule = function(desc, s_vlan_id, c_vlan_id, wan, lan1, lan2, lan3, active) {
	if (!this.new_routercfg.bridge)
		this.new_routercfg.bridge = [];
	var blist = this.new_routercfg.bridge;
	var len = 0;
	for (var idx in blist) {
		if (blist[idx].description == desc)
			return false;
		len++;
	}
	this.new_routercfg.bridge[len] = {
		"active": active,
		"s_vlan_id": s_vlan_id,
		"c_vlan_id": c_vlan_id,
		"wan": wan,
		"lan1": lan1,
		"lan2": lan2,
		"lan3": lan3,
		"description": desc
	};
};

Kbox.prototype.add_firewall_v6_rule = function(desc, proto, src_ip, dst_ip, dst_port, active) {
	if (!this.new_routercfg.firewall_v6)
		this.new_routercfg.firewall_v6 = [];
	var fv6list = this.new_routercfg.firewall_v6;
	var len = 0;
	for (var idx in fv6list) {
		if (fv6list[idx].description == desc)
			return false;
		len++;
	}
	this.new_routercfg.firewall_v6[len] = {
		"active": active,
		"proto": proto,
		"src_ip": src_ip,
		"dst_ip": dst_ip,
		"dst_port": dst_port,
		"description": desc
	};
};

Kbox.prototype.socat = function(src_port, dst_ip, dst_port) {
	$('#div-socat').hide();
	$('#loading').show();
	$('#loading-socat').show();
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'socat/'+src_port+'/'+dst_ip+'/'+dst_port,
		function(json) {
			$('#loading').hide();
			$('#loading-socat').hide()
			$('#div-socat').show()
			$('#value-socat').text("");
                        $("#value-socat").removeClass("glyphicon-remove");
                        $("#value-socat").addClass("glyphicon-ok");
			$('#run-socat').prop("disabled",false);
		}, function(errormsg) {
			$('#loading').hide();
			$('#loading-socat').hide()
			$('#div-socat').show()
			$('#value-socat').text("");
                        $("#value-socat").removeClass("glyphicon-ok");
                        $("#value-socat").addClass("glyphicon-remove");
			$('#run-socat').prop("disabled",false);
	});
};

Kbox.prototype.speedtestDownload = function() {
	$('#div-speedtest-dl').hide();
  	$('#loading').show();
  	$('#loading-speedtest-dl').show();
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'speedtest/download',
		function(json) {
  			$('#loading').hide();
			$('#loading-speedtest-dl').hide()
			$('#div-speedtest-dl').show()
			$('#value-speedtest-dl').text(json["data"]);
			$('#run-speedtest-dl').prop("disabled",false);
		}, function(errormsg) {
  			$('#loading').hide();
			$('#loading-speedtest-dl').hide()
			$('#div-speedtest-dl').show()
			$('#value-speedtest-dl').text("");
			$('#run-speedtest-dl').prop("disabled",false);
	});
};

Kbox.prototype.speedtestUpload = function() {
	$('#div-speedtest-ul').hide();
  	$('#loading').show();
  	$('#loading-speedtest-ul').show();
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'speedtest/upload',
		function(json) {
  			$('#loading').hide();
			$('#loading-speedtest-ul').hide()
			$('#div-speedtest-ul').show()
			$('#value-speedtest-ul').text(json["data"]);
			$('#run-speedtest-ul').prop("disabled",false);
		}, function(errormsg) {
  			$('#loading').hide();
			$('#loading-speedtest-ul').hide()
			$('#div-speedtest-ul').show()
			$('#value-speedtest-ul').text("");
			$('#run-speedtest-ul').prop("disabled",false);
	});
};

Kbox.prototype.upgrade = function() {
	$('#div-upgrade-kbox').hide();
  	$('#loading').show();
  	$('#loading-upgrade-kbox').show();
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'upgrade',
		function(json) {
  			$('#loading').hide();
			$('#loading-upgrade-kbox').hide()
			$('#div-upgrade-kbox').show()
			$('#value-upgrade-kbox').text("");
			$("#value-upgrade-kbox").removeClass("glyphicon-remove");
			$("#value-upgrade-kbox").addClass("glyphicon-ok");
			$('#run-upgrade-kbox').prop("disabled",false);
		}, function(errormsg) {
			$('#loading').hide();
			$('#loading-upgrade-kbox').hide()
			$('#div-upgrade-kbox').show()
			$('#value-upgrade-kbox').text("");
			$("#value-upgrade-kbox").removeClass("glyphicon-ok");
			$("#value-upgrade-kbox").addClass("glyphicon-remove");
			$('#run-upgrade-kbox').prop("disabled",false);
	});
}

Kbox.prototype.hwReset = function() {
	$('#div-hw-reset').hide();
	$('#loading').show();
	$('#loading-hw-reset').show();
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'hw_reset',
		function(json) {
			$('#loading').hide();
			$('#loading-hw-reset').hide()
			$('#div-hw-reset').show()
			$('#value-hw-reset').text("");
			$("#value-hw-reset").removeClass("glyphicon-remove");
			$("#value-hw-reset").addClass("glyphicon-ok");
			$('#run-hw-reset').prop("disabled",false);
		}, function(errormsg) {
			$('#loading').hide();
			$('#loading-hw-reset').hide()
			$('#div-hw-reset').show()
			$('#value-hw-reset').text("");
			$("#value-hw-reset").removeClass("glyphicon-ok");
			$("#value-hw-reset").addClass("glyphicon-remove");
			$('#run-hw-reset').prop("disabled",false);
	});
}

Kbox.prototype.provisioning = function() {
	$('#div-provisioning').hide();
	$('#loading').show();
	$('#loading-provisioning').show();
	this.IO.pcall(AREA.getSkyboxUrl(), "router", this.mac, "provisioning/retry", {},
		function(json) {
			$('#loading').hide();
			$('#loading-provisioning').hide()
			$('#div-provisioning').show()
			$('#value-provisioning').text("");
			$("#value-provisioning").removeClass("glyphicon-remove");
			$("#value-provisioning").addClass("glyphicon-ok");
			$('#run-provisioning').prop("disabled",false);
		}, function(errormsg) {
			$('#loading').hide();
			$('#loading-provisioning').hide()
			$('#div-provisioning').show()
			$('#value-provisioning').text("");
			$("#value-provisioning").removeClass("glyphicon-ok");
			$("#value-provisioning").addClass("glyphicon-remove");
			$('#run-provisioning').prop("disabled",false);
	});
}

Kbox.prototype.exportConf = function() {
	$('#div-export-conf').hide();
	$('#loading').show();
	$('#loading-export-conf').show();
	var blob = new Blob([JSON.stringify(this.new_routercfg)], {type: "application/json"});
	try{
		saveAs(blob, "config_" + this.mac.replace(':','') + ".txt");
		$('#loading').hide();
		$('#loading-export-conf').hide()
		$('#div-export-conf').show()
		$('#value-export-conf').text("");
		$("#value-export-conf").removeClass("glyphicon-remove");
		$("#value-export-conf").addClass("glyphicon-ok");
		$('#run-export-conf').prop("disabled",false);
	}catch(e){
		$('#loading').hide();
		$('#loading-export-conf').hide()
		$('#div-export-conf').show()
		$('#value-export-conf').text("");
		$("#value-export-conf").removeClass("glyphicon-ok");
		$("#value-export-conf").addClass("glyphicon-remove");
		$('#run-export-conf').prop("disabled",false);
	}
}

Kbox.prototype.importConf = function(event) {
	var selectedFile = event.target.files[0];
	var reader = new FileReader();
	var me = this;

	reader.onload = function(event) {
		me.new_routercfg = JSON.parse(event.target.result);
		kbox.setConfig();
	};

  	reader.readAsText(selectedFile);
}

Kbox.prototype.phoneReset = function() {
	$('#div-phone-reset').hide();
	$('#loading').show();
	$('#loading-phone-reset').show();
	this.IO.xcall(AREA.getSkyboxUrl(), "GET", 'router', this.mac, 'phone_reset',
		function(json) {
			$('#loading').hide();
			$('#loading-phone-reset').hide()
			$('#div-phone-reset').show()
			$('#value-phone-reset').text("");
			$("#value-phone-reset").removeClass("glyphicon-remove");
			$("#value-phone-reset").addClass("glyphicon-ok");
			$('#run-phone-reset').prop("disabled",false);
		}, function(errormsg) {
			$('#loading').hide();
			$('#loading-phone-reset').hide()
			$('#div-phone-reset').show()
			$('#value-phone-reset').text("");
			$("#value-phone-reset").removeClass("glyphicon-ok");
			$("#value-phone-reset").addClass("glyphicon-remove");
			$('#run-phone-reset').prop("disabled",false);
	});
}

Kbox.prototype.getDeviceName = function(mac) {
	var name = "Inconnu";
	var mac = mac.toLowerCase();

	var stlist = kbox.new_routercfg.lan_static_ip;
	for (var st in stlist) {
		if (mac == stlist[st].mac.toLowerCase()) {
			name = stlist[st].description;
			return name;
		}
	};

	if (this.routerinfo != null) {
		if((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850") || (kbox.new_routercfg.model === 'mini-itx')) {
			var nic_list = (kbox.new_routercfg.model === 'mini-itx' ? this.nic_list_miniitx : this.nic_list_elcon);
			for (var nic in nic_list) {
				for (var etherdev in kbox.routerinfo.port[nic_list[nic]].list_equipments) {
					if (kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].mac == mac.toLowerCase()) {
						name = (kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].name == "none"
								|| kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].name == null ?
								"Inconnu" : kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].name)
						return name;
					}
				}
		}
		} else {
			for (var nic in this.nic_list_netgear) {
				if (kbox.routerinfo[this.nic_list_netgear[nic]].name_equipment == mac.toLowerCase()) {
					name = (kbox.routerinfo[this.nic_list_netgear[nic]].name_equipment == "none"
							|| kbox.routerinfo[this.nic_list_netgear[nic]].name_equipment == null ?
							"Inconnu" : kbox.routerinfo[this.nic_list_netgear[nic]].name_equipment)
					return name;
				}
			}
		}

		if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850")) {
			for (var wifidev in kbox.routerinfo.wireless.list_equipments) {
				if (kbox.routerinfo.wireless.list_equipments[wifidev].mac_addr == mac.toLowerCase()) {
					name = (kbox.routerinfo.wireless.list_equipments[wifidev].name == "none" ? "Inconnu" : kbox.routerinfo.wireless.list_equipments[wifidev].name);
					return name;
				}
			}
		} else {
			//Tsss
			for (var wifidev in kbox.routerinfo.wireless.list_equipment) {
				if (kbox.routerinfo.wireless.list_equipment[wifidev].mac_addr == mac.toLowerCase()) {
					name = (kbox.routerinfo.wireless.list_equipment[wifidev].name == "none" ? "Inconnu" : kbox.routerinfo.wireless.list_equipment[wifidev].name);
					return name;
				}
			}
		}
	}

	return name;
};

Kbox.prototype.unlockAll = function() {
	$("div *").prop('disabled', false);
};

Kbox.prototype.lockAll = function() {
	$("div *").prop('disabled',true);
	$("#surprise").prop("disabled", false);
	if (this.configStatus == 500 || this.configStatus == 403)
		$("#search").prop('disabled', false);
};

Kbox.prototype.TiTi = function() {
	window.open("/surprise", "surprise", "menubar=no, status=no, scrollbars=no,"+
			"menubar=no, resizable=no, directories=no, location=no, width=478, height=376");
};

Kbox.prototype.displayKMenu = function(json) {
	if (this.sub_id)
		$('#search').attr('onclick', "window.open('https://clients.caps.services/','_blank');")

	if (!json["data"].company) {
		document.title = 'KBOX';
		$('#logo').remove();
	} else {
		document.title = json["data"].company + ' - KBOX';
		if (json["data"].company == "KSYS") {
			$('#search').attr('onclick', "window.open('https://k-sys.caps.services/MonCompteKSys/','_blank');")
			$('#logo').attr('href', 'http://k-sys.ch')
			$('#logo-img').attr('src', 'img/logo-ksys-blanc.png');
			$('#logo-img').attr('style', 'height:15px;');
		} else {
			$('#logo').attr('href', '//www.k-net.fr')
			$('#logo-img').attr('src', 'img/logo-knet-blanc.png');
		}
	}

	if (!json["data"].display_ugly_panel){
		$("#kmenu-info").show();
		$("#kmenu-advanced").show();
		$("#kmenu-tools").show();
		$("#a_kbox").show();
		$("#btn-versions").show();
		$("#btn-help").show();
		$('#img-logo-kbox').attr('src', ((json["data"].model == "mini-itx") ? 'img/logo-kbox-pro.png' : 'img/logo-kbox.png'));
		$('#kbox-name').text(((json["data"].model == "mini-itx") ? 'KBOX PRO' : 'KBOX'));
		if (json["data"].model == "i4600") {
			$('#img-logo').attr('src', 'img/elcon.png');
		} else if (json["data"].model == "i4850") {
			$('#img-logo').attr('src', 'img/i4850.png');
		} else if (json["data"].model == "mini-itx") {
			$('#img-logo').attr('src', 'img/mini-itx.png');
		} else {
			$('#img-logo').attr('src', 'img/kbox.png');
		}
		$("#home_kbox").removeClass("toHide");
		$("#home_loading").addClass("toHide");
		if (json["data"].is_admin)
			$("#kmenu-admin").show();
		else
			$("#kmenu-admin").hide();
		if (((json["data"].model == "v2") && ((json["data"].client_pro) || (json["data"].is_vpn_client))) ||
		((json["data"].model == "mini-itx") && ((json["data"].client_pro) || (json["data"].is_monit_client) || (json["data"].is_vpn_client) ||
		(json["data"].is_failover) || (json["data"].is_failover_4g) || (json["data"].is_antivirus) || (json["data"].is_acceleration) || (json["data"].is_firewall))))
			$("#kmenu-supervision").show();
		else
			$("#kmenu-supervision").hide();
		if ((json["data"].model == "i4600") || (json["data"].model == "i4850"))
			$("#kmenu-phone").show();
		else
			$("#kmenu-phone").hide();
	}else{
		$("#kmenu-info").hide();
		$("#kmenu-advanced").hide();
		$("#kmenu-tools").hide();
		$("#a_kbox").hide();
		$("#btn-versions").hide();
		$("#btn-help").hide();
		$("#kmenu-admin").hide();
		$("#kmenu-supervision").hide();
		$("#kmenu-phone").hide();
		$("#kcontent").load('html/supervision.html', function() {
			page_init();
			page_init = null;
		});
	}
};

var kbox;
var instance = null;
