function Menu() {
	this.page = '';
	// this.init();
}

Menu.prototype.init = function() {
	$(".load-bgrd").hide();
	$("#popup-loading").hide();
	$("html").find("*").off("click");
	// if (!this.logged) return false;
	switch(this.page) {
		case 'lan':
			$("#kmenu-lan").parent().addClass('active');
			$("#kcontent").load('html/lan.html', function() {
				page_init();
				page_init = null;
			});
			break;
		case 'wifi':
			if ((kbox.routercfg.model === "i4600") || (kbox.routercfg.model === "i4850")) {
				$("#kmenu-wifi").parent().addClass('active');
				$("#kcontent").load('html/wifi_elcon.html', function() {
					page_init();
					page_init = null;
				});
			} else if (kbox.routercfg.model === "mini-itx") {
				$("#kmenu-wifi").parent().addClass('active');
				$("#kcontent").load('html/wifi_minix.html', function() {
					page_init();
					page_init = null;
				});
			} else {
				$("#kmenu-wifi").parent().addClass('active');
				$("#kcontent").load('html/wifi.html', function() {
					page_init();
					page_init = null;
				});
			}
			break;
		case 'medias':
			if ((kbox.routercfg.model === "i4600") || (kbox.routercfg.model === "i4850")) {
				$("#kmenu-medias").parent().addClass('active');
				$("#kcontent").load('html/medias_elcon.html', function() {
					page_init();
					page_init = null;
				});
			} else {
				$("#kmenu-medias").parent().addClass('active');
				$("#kcontent").load('html/medias.html', function() {
					page_init();
					page_init = null;
				});
			}
			break;
		case 'phone':
			if ((kbox.routercfg.model === "i4600") || (kbox.routercfg.model === "i4850")) {
				$("#kmenu-phone").parent().addClass('active');
				$("#kcontent").load('html/phone.html', function() {
					page_init();
					page_init = null;
				});
			}
			break;
		case 'advanced':
			$("#kmenu-advanced").parent().addClass('active');
			$("#kcontent").load('html/advanced.html', function() {
				page_init();
				page_init = null;
			});
			break;
		case 'tools':
			$("#kmenu-tools").parent().addClass('active');
			$("#kcontent").load('html/tools.html', function() {
				page_init();
				page_init = null;
			});
			break;
		case 'supervision':
			if ((kbox.routercfg.client_pro) || (kbox.routercfg.is_monit_client) || (kbox.routercfg.is_vpn_client) || (kbox.routercfg.is_failover) ||
			(kbox.routercfg.is_antivirus) || (kbox.routercfg.is_acceleration) || (kbox.routercfg.is_firewall) || (kbox.routercfg.is_failover_4g)) {
				$("#kmenu-supervision").parent().addClass('active');
				$("#kcontent").load('html/supervision.html', function() {
					page_init();
					page_init = null;
				});
			}
			break;
		case 'admin':
			if (kbox.routercfg.is_admin == 1) {
					$("#kmenu-admin").parent().addClass('active');
					$("#kcontent").load('html/admin.html', function() {
						if (!kbox.routerinfo)
							$(".load-bgrd").css('display', 'block');
						page_init();
						page_init = null;
					});
			}
			break;
		case 'version':
			$("#kmenu-version").parent().addClass('active');
			$("#kcontent").load('html/version.html', function() {
				page_init();
				page_init = null;
			});
			break;
		case 'info':
			$("#kmenu-info").parent().addClass('active');
			$("#kcontent").load('html/info.html', function() {
				if (!kbox.routerinfo)
					$(".load-bgrd").css('display', 'block');
				page_init();
				page_init = null;
			});
			break;
		default:
			$("#btn-help").parent().addClass('active');
			$("#btn-help").focus()
			$("#kcontent").load('html/home.html', function() {
				page_init();
				page_init = null;
			});
			break;
	}
};

Menu.prototype.goTo = function(page) {
	this.page = page;
	$(".klink").removeClass('active');
	this.init()
};

var menu;
