function Medias(){

}

Medias.prototype.rollBack = function() {
	this.update();
};

Medias.prototype.update = function() {
	if ((kbox.new_routercfg.model === "i4600") || ((kbox.new_routercfg.model === "i4850") && ($.cmpIcoteraFirm(kbox.routercfg.firmware_version, "16.0")))){
		$("#elcon-dlna").removeClass("toHide");
		$("#elcon-smb").removeClass("toHide");
		$("#elcon-refresh").removeClass("toHide");
		$("#elcon-umount").removeClass("toHide");
	} else if((kbox.new_routercfg.model === "v1") || (kbox.new_routercfg.model === "v2")){
		$("#usb_option").removeClass("toHide");
		$("#samba_option").removeClass("toHide");
	}

	if ((kbox.routercfg.model == "v1") && (kbox.routercfg.firmware_version >= "11") ||
		(kbox.routercfg.model == "v2")){
		$("#v2-dlna").removeClass("toHide");
	}

	if (kbox.new_routercfg.upnp_enable)
		$("#div-upnp-rules").removeClass("toHide");
	else
		$("#div-upnp-rules").addClass("toHide");

	if (kbox.routercfg.model == "v2" && kbox.routercfg.firmware_version >= "11")
		$("#v2-nfs").removeClass("toHide");

	if ((kbox.new_routercfg.dlna_enable_elcon) || (kbox.new_routercfg.smbd_enable_elcon)) {
		$("#elcon-refresh").removeClass("toHide");
		$("#elcon-umount").removeClass("toHide");
	} else {
		$("#elcon-refresh").addClass("toHide");
		$("#elcon-umount").addClass("toHide");
	}

	$("#popup-loading").hide();
	kbox.showChange()
	$("#dlna_enable").prop('checked', kbox.new_routercfg.dlna_enable);
	$("#dlna_enable_elcon").prop('checked', kbox.new_routercfg.dlna_enable_elcon);
	$("#smbd_enable_elcon").prop('checked', kbox.new_routercfg.smbd_enable_elcon);
	$("#usb_enable").prop('checked',kbox.new_routercfg.usb_enable);
	$("#upnp_enable").prop('checked',kbox.new_routercfg.upnp_enable);
	$("#nfs_enable").prop('checked',kbox.new_routercfg.nfs_enable);
	$('#dlna_port_elcon option[value="'+kbox.new_routercfg.dlna_port_elcon+'"]').prop('selected', true);
	$('#smbd_port_elcon option[value="'+kbox.new_routercfg.smbd_port_elcon+'"]').prop('selected', true);
	$(".smbd_authentication").hide();
	this.__checkUSBPort("smbd_enable_elcon", kbox.new_routercfg.smbd_enable_elcon);
	this.__checkUSBPort("dlna_enable_elcon", kbox.new_routercfg.dlna_enable_elcon);
	this.__SMB();
	this.__USB();
};

Medias.prototype.onEvent = function() {
	var me = this;
	$("body").off();
	$("body").on("change", function(event){
		var elem = $("#"+event.target.id);
		switch(event.target.id){
			case "usb_enable":
				var val = me.__toggle(event.target.id);
					me.__switchUSB(val);
				break;
			case "dlna_enable":
				var val = me.__toggle(event.target.id);
				if (val){
					kbox.new_routercfg.upnp_enable = true;
  			        kbox.new_routercfg.usb_enable = true;
				}
				break;
			case "dlna_enable_elcon":
				var val = me.__toggle(event.target.id);
				kbox.new_routercfg.dlna_port_elcon = $("#dlna_port_elcon option:selected").val();
				me.__checkUSBPort(event.target.id, val);
				break;
			case "smbd_enable_elcon":
				var val = me.__toggle(event.target.id);
				kbox.new_routercfg.smbd_port_elcon = $("#smbd_port_elcon option:selected").val();
				me.__checkUSBPort(event.target.id, val);
				break;
			case "nfs_enable":
				var val = me.__toggle(event.target.id);
				if (val)
					kbox.new_routercfg.usb_enable = true;
				break;
			case "upnp_enable":
				var val = me.__toggle(event.target.id);
				if (val)
					kbox.new_routercfg.dlna_enable = false;
				if(!$('#upnp_enable').prop('checked'))
					alert("Si vous possédez une (des) Dune(s), en désactivant cette option, celle(s)-ci pourrai(en)t avoir un fonctionnement dégradé.");
				break;
		}

		if (elem.hasClass("input-change"))
			me.__checkForInput(elem);
		else if (elem.hasClass("select-change")) {
			kbox.new_routercfg[event.target.id] = event.target.value;
			if (event.target.id == "dlna_port_elcon")
				kbox.new_routercfg['smbd_port_elcon'] = event.target.value;
			if (event.target.id == "smbd_port_elcon")
				kbox.new_routercfg['dlna_port_elcon'] = event.target.value;
		}

		me.update();
	});

	$("body").on("click", function(event){
		switch(event.target.id){
			case "umount-usb":
				kbox.umountUSB(kbox.new_routercfg.smbd_port_elcon);
				break;
			case "refresh-usb":
				kbox.refreshUSB(kbox.new_routercfg.smbd_port_elcon);
				break;
			case "btn-upnp-rules":
				kbox.getUpnpRules();
				break;
		}
	})

};

Medias.prototype.__SMB = function() {
	if (kbox.new_routercfg.smbd_enable && kbox.new_routercfg.smbd_enable != "0") {
		$("#smbd_share_name").val(kbox.new_routercfg.smbd_share_name);
		$("#smbd_share_desc").val(kbox.new_routercfg.smbd_share_desc);
		$('#smbd_enable option[value="'+kbox.new_routercfg.smbd_enable+'"]').prop('selected', true);
		$("#smbd_options").show();
		if (kbox.new_routercfg.workgroup)
			$("#workgroup").val(kbox.new_routercfg.workgroup);

		if (kbox.new_routercfg.smbd_autoshare) {
			$('#smbd_autoshare option[value="'+kbox.new_routercfg.smbd_autoshare+'"]').prop('selected', true);
		}

		if (kbox.new_routercfg.smbd_enable == "2") {
			$(".smbd_authentication").show();
			$("#smbd_user").val(kbox.new_routercfg.smbd_user);
			$("#smbd_passwd").val(kbox.new_routercfg.smbd_passwd);
		}
	}
	else {
		$('#smbd_enable option[value="0"]').prop('selected', true);
		$("#smbd_options").hide();
	}
};

Medias.prototype.__USB = function() {
	if (!kbox.new_routercfg[$("#usb_enable").attr('id')])
		$("#smbd_enable").prop("disabled",true);
	else
		$("#smbd_enable").prop("disabled",false);
};

Medias.prototype.__toggle = function(id) {
	kbox.new_routercfg[id] = !kbox.new_routercfg[id];
	return kbox.new_routercfg[id];
};

Medias.prototype.__switchUSB = function(bool) {
	if (bool){
		if (kbox.new_routercfg.smbd_enable)
	        kbox.new_routercfg.smbd_enable = false;
	    if (kbox.new_routercfg.nfs_enable)
	        kbox.new_routercfg.nfs_enable = false;
	    $("#smbd_enable").prop("disabled",true);
      }else
        $("#smbd_enable").prop("disabled",false);
};

Medias.prototype.__checkUSBPort = function(id, value) {
	if (id == "smbd_enable_elcon") {
		$("#smbd_port_elcon").prop("disabled", !value);
	}
	if (id == "dlna_enable_elcon") {
		$("#dlna_port_elcon").prop("disabled", !value);
	}
};

Medias.prototype.__checkForInput = function(elem) {
	kbox.new_routercfg[elem.attr('id')] = elem.val();
 	kbox.Check.checktype(elem);
};
